=== debian/changelog ===
geographiclib (1.35-2ubuntu1) utopic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use dh-autoreconf to get new libtool macros for ppc64el.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 27 Apr 2014 15:12:41 -0400

geographiclib (1.35-2) unstable; urgency=low

  * Fixed README.Debian to document use of the new download scripts by
    Charles K. instead of my previous scripts.
  * Patch datadir updated to use the correct data path in geographic-get-* 
    scripts.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sun, 16 Mar 2014 20:29:01 +0100

geographiclib (1.35-1) unstable; urgency=low

  * Sigh, license changed since 1.12 but it has never been annotated in 
    debian/copyright. Now changed to modern DEP5 format and all authors
    and contributors also annotated. (closes: #741599)
  * New upstream release with minor changes.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sun, 16 Mar 2014 14:03:59 +0100

geographiclib (1.34-1) unstable; urgency=low

  * New upstram release. It now includes new programs to download data.
  * Policy bumped to 3.9.5.
  * Vcs-* fields moved to canonical form to make lintian happy.
  * Now using modern debhelper instead of cdbs.
  * Debhelper level set to 9.
  * Patchset refreshed.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 12 Mar 2014 10:03:54 +0100
