=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem autoconf \
		  --sourcedirectory=$(CURDIR) --with python2,autoreconf

override_dh_auto_configure:
	dh_auto_configure --  --datadir=/usr/share/geographiclib --prefix=/usr

override_dh_auto_install:
	make -C python DESTDIR=$(CURDIR)/debian/tmp install
	dh_auto_install
